﻿#pragma once

#define DEF_USERMGR_BG_COLOR					Color(255, 255, 255, 255)
#define DEF_USERMGR_BG_OUTLINE_COLOR			Color(255, 201, 201, 201)
#define DEF_ITEM_BG_COLOR						Color(255, 229, 243, 255)
#define DEF_ITEM_OUTLINE_COLOR					Color(255, 203, 230, 255)
#define DEF_ITEM_BG_HIGHLIGHT_COLOR				Color(255, 191, 224, 255)
#define DEF_ITEM_OUTLINE_HIGHLIGHT_COLOR		Color(255, 151, 199, 242)

//#define DEF_USERMGR_ITEM_FONT_NAME				(L"나눔고딕")
#define DEF_USERMGR_ITEM_FONT_HEIGHT			(9)
#define DEF_USERMGR_ITEM_FONT_STYLE				(FontStyleRegular)
#define DEF_USERMGR_ITEM_FONT_COLOR				(Color(255, 0, 0, 0))

#define DEF_ITEM_GAP_WIDTH						(1)
#define DEF_ITEM_MARGIN_Y						(2)
#define DEF_ITEM_NAME_LEFT_POS_X				(5)
#define DEF_USERMGR_HEIGHT						(45)
#define DEF_ITEM_HEIGHT							(20)
#define DEF_ONE_SCROLL_PAGE_WIDTH				(42)

#define ID_BTN_USERMGR_ADD						(0x5001)
#define ID_BTN_ARROW_UP							(0x5002)
#define ID_BTN_ARROW_DOWN						(0x5003)


// CInfoUserMgrWnd

class CInfoUserMgrWnd : public CWnd
{
	DECLARE_DYNAMIC(CInfoUserMgrWnd)

public:
	CInfoUserMgrWnd();
	virtual ~CInfoUserMgrWnd();

	typedef struct _usermgr_item_info
	{
		CString					strName;
		CString					strID;
		CRect					rtItem;
		CRect					rtName;
		CSize					szName;
		CRect					rtDelete;
		BOOL					bHoverDelete;
		BOOL					bDown;
		BOOL					bDownDelete;

		_usermgr_item_info()
		{
			strName = _T("");
			strID = _T("");

			rtItem.SetRectEmpty();
			rtName.SetRectEmpty();
            szName.SetSize(0, 0);
			rtDelete.SetRectEmpty();

			bHoverDelete = FALSE;
			bDown = FALSE;
			bDownDelete = FALSE;
		}
	} USERMGR_ITEM_INFO, *PUSERMGR_ITEM_INFO;

protected:
	DECLARE_MESSAGE_MAP()

private:
	void						RecalcItemInfo();
	CNMImgButton				m_btnAdd;
	CNMImgButton				m_btnArrowUP;
	CNMImgButton				m_btnArrowDown;
	BOOL						m_bTracking;
	int m_nScrollPage;
	Color						m_crBG;
	Color						m_crBGOutline;
	Color						m_crItemBG;
	Color						m_crItemOutline;
	Color						m_crItemBGHighlight;
	Color						m_crItemOutlineHighlight;
	CRect						m_rtWnd;
	CRect						m_rtBtnAdd;
	CRect						m_rtItem;
	
	Image*						m_pImgDelete;
	Image*						m_pImgDeleteOver;

	WCHAR						m_wszFontName[64];
	REAL						m_nFontHeight;
	FontStyle					m_fontStyle;
	Color						m_crText;
	CPtrArray					m_ptrArItem;

	int GetScrollDiff(){ return m_nScrollPage * DEF_ONE_SCROLL_PAGE_WIDTH;}

public:
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnDestroy();
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnPaint();
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnMouseHover(UINT nFlags, CPoint point);
	afx_msg void OnMouseLeave();
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnBtnClickedUserMgrAdd();
	afx_msg void OnBtnClickedArrowUP();
	afx_msg void OnBtnClickedArrowDown();
	afx_msg BOOL OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message);
	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
	afx_msg LRESULT OnUserMgrAddUser(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnUserMgrAddORGUser(WPARAM wParam, LPARAM lParam);

	afx_msg LRESULT OnUserMgrMaxAddUser(WPARAM wParam, LPARAM lParam);

	void						SetImgBGPath(CString strFileName);
	void						SetImgDeletePath(CString strFileName, CString strFileNameOver);
	void						SetFontConfig(WCHAR* wszFontName, REAL nFontHeight, FontStyle style, Color crText);
	void						ClearUserMgrItemAll();
	_usermgr_item_info*			AllocUserMgrItem(CString strName, CString strID);
	void						AddUserMgrItem(CString strID, CString strName);
	void						DeleteUserMgrItem(_usermgr_item_info* pUMInfoDel);
	void						UpdateWndInfo(_usermgr_item_info* pUMInfo);
};
